SCTP Socket API Extensions for Concurrent Multipath Transfer
Internet-Draft draft-dreibholz-tsvwg-sctpsocket-multipath-24
Thomas Dreibholz
Simula Metropolitan Centre for Digital Engineering
Pilestredet 52
0167 Oslo
Norway
dreibh@simula.no
https://www.simula.no/people/dreibh
Martin Becke
HAW Hamburg, Informatics Department
Berliner Tor 7
20099 Hamburg
Germany
+49-40-42875-8104
martin.becke@haw-hamburg.de
http://www.scimbe.de/about.html
Hakim Adhari
University of Duisburg-Essen, Institute for Experimental Mathematics
Ellernstraße 29
45326 Essen
Germany
hakim.adhari@uni-due.de
17 September 2022
Internet-Draft
This document describes extensions to the SCTP sockets API for configuring the CMT-SCTP and CMT/RP-SCTP extensions.
Introduction
This draft describes extensions to the SCTP sockets API (see [RFC6458], [RFC4960]) which allow an application to configure the behaviour of the Concurrent Multipath Transfer (CMT) extensions CMT-SCTP, CMT/RPv1-SCTP, CMT/RPv2-SCTP and MPTCP-like (see [I-D.tuexen-tsvwg-sctp-multipath], [Globecom2010], [PAMS2012], [Dre2012], [PAMS2011], [SoftCOM2011], [ConTEL2011], [AINA2010], [IAS2006]).
Concurrent Multipath Transfer and Resource Pooling Activation/Deactivation (SCTP_CMT_ON_OFF)
This socket option activates or deactivates CMT and sets the corresponding Resource Pooling variant to be applied. The sctp_assoc_value structure is used to specify the association for which the CMT state should be changed and the new CMT state.
Definition of the sctp_assoc_value structure:

struct sctp_assoc_value {
   sctp_assoc_t assoc_id;
   uint32_t     assoc_value;
};

assoc_id:
Holds the identifier for the association of which the CMT state should be changed. Ignored for one-to-one style sockets.
assoc_value:
0
Turns CMT off.
1
Turns plain CMT-SCTP on. No Resource Pooling is applied.
2
Turns CMT-SCTP on. CMT/RPv1 Resource Pooling as defined in [AINA2010] is applied.
3
Turns CMT-SCTP on. CMT/RPv2 Resource Pooling as defined in [ConTEL2011] is applied.
4
Turns CMT-SCTP on. MPTCP-like Resource Pooling as defined in [SoftCOM2011], [ConTEL2011], [PAMS2012] is applied.
Testbed Platform
A large-scale and realistic Internet testbed platform with support for the multi-homing feature of the underlying SCTP protocol is NorNet. A description of NorNet is provided in [PAMS2013-NorNet], [ComNets2013-Core], some further information can be found on the project website [NorNet-Website].
Security Considerations
Security considerations for the SCTP sockets API are described by [RFC6458].
IANA Considerations
This document does not require IANA actions.
Acknowledgments
The authors would like to thank Michael Tuexen for his support.
References
Normative References
[RFC4960]

Stream Control Transmission Protocol
R. Stewart, Ed.
September 2007
RFC 4960
DOI 10.17487/RFC4960
[RFC6458]

Sockets API Extensions for the Stream Control Transmission Protocol (SCTP)
R. Stewart
M. Tuexen
K. Poon
P. Lei
V. Yasevich
December 2011
RFC 6458
DOI 10.17487/RFC6458
[I-D.tuexen-tsvwg-sctp-multipath]

Load Sharing for the Stream Control Transmission Protocol (SCTP)
Paul D. Amer
University of Delaware
Martin Becke
HAW Hamburg
Thomas Dreibholz
SimulaMet
Nasif Ekiz
University of Delaware
Janardhan Iyengar
Franklin and Marshall College
Preethi Natarajan
Cisco Systems
Randall R. Stewart
Netflix
Michael Tuexen
Muenster Univ. of Appl. Sciences
9 February 2022
Internet-Draft draft-tuexen-tsvwg-sctp-multipath-23
Informative References
[Dre2012]

Evaluation and Optimisation of Multi-Path Transport using the Stream Control Transmission Protocol
ThomasDreibholz
13 March 2012
Habilitation Treatise
[PAMS2012]

Simulation and Experimental Evaluation of Multipath Congestion Control Strategies
ThomasDreibholz
HakimAdhari
MartinBecke
Erwin PaulRathgeb
29 March 2012
Proceedings of the 2nd International Workshop on Protocols and Applications with Multi-Homing Support(PAMS) ISBN978-0-7695-4652-0, DOI10.1109/WAINA.2012.186
[SoftCOM2011]

Evaluation of A New Multipath Congestion Control Scheme using the NetPerfMeter Tool-Chain
ThomasDreibholz
MartinBecke
HakimAdhari
Erwin PaulRathgeb
16 September 2011
Proceedings of the 19th IEEE International Conference on Software, Telecommunications and Computer Networks(SoftCOM) Pages 1-6, ISBN978-953-290-027-9
[PAMS2011]

Evaluation of Concurrent Multipath Transfer over Dissimilar Paths
HakimAdhari
ThomasDreibholz
MartinBecke
Erwin PaulRathgeb
MichaelTüxen
22 March 2011
Proceedings of the 1st International Workshop on Protocols and Applications with Multi-Homing Support(PAMS) Pages 708-714, ISBN978-0-7695-4338-3, DOI10.1109/WAINA.2011.92
[ConTEL2011]

On the Impact of Congestion Control for Concurrent Multipath Transfer on the Transport Layer
ThomasDreibholz
MartinBecke
HakimAdhari
Erwin PaulRathgeb
16 June 2011
Proceedings of the 11th IEEE International Conference on Telecommunications(ConTEL) Pages 397-404, ISBN978-953-184-152-8
[AINA2010]

Applying TCP-Friendly Congestion Control to Concurrent Multipath Transfer
ThomasDreibholz
MartinBecke
JobinPulinthanath
Erwin PaulRathgeb
21 April 2010
Proceedings of the 24th IEEE International Conference on Advanced Information Networking and Applications(AINA) Pages 312-319, ISBN978-0-7695-4018-4, DOI10.1109/AINA.2010.117
[Globecom2010]

On the Use of Concurrent Multipath Transfer over Asymmetric Paths
ThomasDreibholz
MartinBecke
Erwin PaulRathgeb
MichaelTüxen
7 December 2010
Proceedings of the IEEE Global Communications Conference(GLOBECOM) ISBN978-1-4244-5637-6, DOI10.1109/GLOCOM.2010.5683579
[IAS2006]

Concurrent Multipath Transfer Using SCTP Multihoming Over Independent End-to-End Paths
JanardhanR.Iyengar
PaulD.Amer
RandallStewart
October 2006
IEEE/ACM Transactions on Networking, Volume 14, Number 5, Pages 951-964, ISSN1063-6692, DOI10.1109/TNET.2006.882843
[PAMS2013-NorNet]

Design and Implementation of the NorNet Core Research Testbed for Multi-Homed Systems
ThomasDreibholz
Ernst GunnarGran
27 March 2013
Proceedings of the 3nd International Workshop on Protocols and Applications with Multi-Homing Support(PAMS) Pages 1094-1100, ISBN978-0-7695-4952-1, DOI10.1109/WAINA.2013.71
[ComNets2013-Core]

NorNet Core – A Multi-Homed Research Testbed
Ernst GunnarGran
ThomasDreibholz
AmundKvalbein
14 March 2014
Computer Networks, Special Issue on Future Internet Testbeds Volume 61, Pages 75-87, ISSN1389-1286, DOI10.1016/j.bjp.2013.12.035
[NorNet-Website]

NorNet – A Real-World, Large-Scale Multi-Homing Testbed
Thomas Dreibholz
2022